{% extends 'base.html' %}

{% block content %}
{% autoescape false %}
<div class="fr-col-12">
    <div class="fr-grid-row gn-wrapper">
        <div class="fr-col-12 fr-col-lg-2">
            {% include 'content/side-nav.html' %}
        </div>

        <div class="fr-col-12 fr-col-lg-10">
            <section class="gn-main-content">
                <header class="fr-grid-row fr-grid-row--middle">
                    <h1 class="fr-h3">Publier le contenu : {{ content.title }}</h1>
                </header>

                <div class="fr-tabs gn-tabs">
                    <ul class="fr-tabs__list"
                        role="tablist"
                        aria-label="Publier un contenu">
                        {% if content.communications|length > 0 %}
                            {% for communication in content.communications %}
                                {% if communication.channel == 'EMAIL' %}
                                    <li role="presentation">
                                        <button id="email-tab"
                                            class="fr-tabs__tab"
                                            tabindex="0"
                                            role="tab"
                                            aria-selected="true"
                                            aria-controls="email">
                                            <span class="fr-icon-mail-fill fr-icon--sm" aria-hidden="true"></span>
                                            Email - Newsletter
                                        </button>
                                    </li>
                                {% elseif communication.channel == 'SMS' %}
                                    <li role="presentation">
                                        <button id="sms-tab"
                                            class="fr-tabs__tab"
                                            tabindex="-1"
                                            role="tab"
                                            aria-selected="false"
                                            aria-controls="sms">
                                            <span class="fr-icon-message-2-fill fr-icon--sm" aria-hidden="true"></span>
                                            Alerte SMS
                                        </button>
                                    </li>
                                {% elseif communication.channel == 'WEBSITE' %}
                                    <li role="presentation">
                                        <button id="website-tab"
                                            class="fr-tabs__tab"
                                            tabindex="-1"
                                            role="tab"
                                            aria-selected="false"
                                            aria-controls="internet">
                                            <span class="fr-icon-window-fill fr-icon--sm" aria-hidden="true"></span>
                                            Site Internet
                                        </button>
                                    </li>
                                {% elseif communication.channel == 'CHANNEL' %}
                                    <li role="presentation">
                                        <button id="communication-{{ communication.id }}-tab"
                                                class="fr-tabs__tab"
                                                tabindex="-1"
                                                role="tab"
                                                aria-selected="false"
                                                aria-controls="communication-{{ communication.id }}">
                                            <span class="fr-icon-{{ communication.organisationChannel|channelIcon }} fr-icon--sm" aria-hidden="true"></span>
                                            {{ communication.organisationChannel.channelName }}
                                        </button>
                                    </li>
                                {% endif %}
                            {% endfor %}
                        {% else %}
                            <div class="fr-col-12 fr-badge fr-badge--warning">Aucun canal de communication s&eacute;lectionn&eacute; pour ce contenu</div>
                        {% endif %}
                    </ul>

                    {% if content.communications|length > 0 %}
                        {% for communication in content.communications %}
                            {% if communication.channel == 'EMAIL' %}
                                <div id="email"
                                    class="fr-tabs__panel"
                                    role="tabpanel"
                                    aria-labelledby="email-tab"
                                    tabindex="0">
                                    {% include 'content/publication/publish-email-tab.html' with {'communication': communication} %}
                                </div>
                            {% elseif communication.channel == 'SMS' %}
                                <div id="sms"
                                    class="fr-tabs__panel fr-tabs__panel--selected"
                                    role="tabpanel"
                                    aria-labelledby="sms-tab"
                                    tabindex="0">
                                    {% include 'content/publication/publish-sms-tab.html' with {'communication': communication} %}
                                </div>
                            {% elseif communication.channel == 'WEBSITE' %}
                                <div id="internet"
                                    class="fr-tabs__panel"
                                    role="tabpanel"
                                    aria-labelledby="internet-tab"
                                    tabindex="0">
                                    {% include 'content/publication/publish-website-tab.html' with {'communication': communication} %}
                                </div>
                            {% elseif communication.channel == 'CHANNEL' %}
                                <div id="communication-{{ communication.id }}"
                                    class="fr-tabs__panel fr-tabs__panel--selected"
                                    role="tabpanel"
                                    aria-labelledby="communication-{{ communication.id }}-tab"
                                    tabindex="0">
                                    {% include 'content/publication/publish-channel-tab.html' with {'communication': communication} %}
                                </div>
                            {% endif %}
                        {% endfor %}
                    {% endif %}

                </div>
            </section>
        </div>
    </div>
</div>

{% include './modals/publication/schedule-publication.html' %}
{% include './modals/publication/publication-confirmation.html' %}
{% include './modals/publication/publication-social-network-confirmation.html' %}
{% include './modals/publication/publication-cannot-be-done.html' %}

{% endautoescape %}
{% endblock %}

{% block script %}
{% autoescape false %}

<script src="/assets/tinymce/tinymce.min.js"></script>
<script src="/assets/tinymce-i18n/langs5/fr_FR.js"></script>
<script type="text/javascript">

    $('button.send-publication').on('click', function (e) {
        event.preventDefault();
        event.stopPropagation();
        GN.closeModal('publicationConfirmationModal');
        var form = $(this).parents('form:first');
        var channel = $('input[name="communication-channel"]', form).val();
        let channelRoute = '/action/publish/' + channel;
        if(channel == 'CHANNEL') {
            let channelId = $('input[name="channel-id"]', form).val();
            channel = "CHANNEL-" + channelId;
        }
        $('form#publicationForm' + channel).attr('action', channelRoute );
        $('form#publicationForm' + channel + ' button.save-communication').click();
    });

    $('button.confirm-publication').on('click', function(e) {
        event.preventDefault();
        event.stopPropagation();
        let form = $(this).parents('form:first');
        let channel = $('input[name="communication-channel"]', form).val();
        const channelId = $('input[name="channel-id"]', form).val();
        let scheduleDate = $('input[name="communication-schedule-date"]', form).val();
        let distributionListValue = $('select[name="communication-distributionList"] option:selected').val();
        let distributionListLabel = $('select[name="communication-distributionList"] option:selected').html();

        if (!distributionListValue && channel !== 'CHANNEL') {
            GN.openModal('publicationCannotBeDoneModal');
        } else {
            let modal;
            if (channel === 'CHANNEL') {
                modal = 'publicationOnSocialNetworkConfirmationModal';
                GN.openModal(modal);
                distributionListLabel = $('input[name="communication-channel-name"]', form).val();
            } else {
                modal = 'publicationConfirmationModal';
                GN.openModal(modal);
            }

            $('#' + modal + ' input[name="communication-channel"]').val(channel);
            $('#' + modal + ' input[name="channel-id"]').val(channelId ?? null);
            if (scheduleDate) {
                $('#' + modal + ' div.fr-alert--info').hide();
                $('#' + modal + ' div.fr-alert--warning span').html(scheduleDate);
                $('#' + modal + ' div.fr-alert--warning').show();
            } else {
                $('#' + modal + ' div.fr-alert--warning').hide();
                $('#' + modal + ' div.fr-alert--info span').html(distributionListLabel);
                $('#' + modal + ' div.fr-alert--info').show();
            }
        }
    });

    $('button.schedule-publication').on('click', function () {
        let communicationId = $(this).data('communicationId');
        let scheduleDate = $(this).data('communicationScheduleDate');
        GN.openModal('schedulePublicationModal');
        $('#schedulePublicationModal input[name="communication-id"]').val(communicationId);
        if (scheduleDate) {
            const scheduleDateAsArray = scheduleDate.split(' ');
            $('#schedulePublicationModal input[name="sending-date"]').val(scheduleDateAsArray[0]);
            $('#schedulePublicationModal input[name="sending-time"]').val(scheduleDateAsArray[1]);
            $('button#cancel-scheduling').show();
        } else {
            $('button#cancel-scheduling').hide();
        }
    });

    $('button#cancel-scheduling').on('click', function (e) {
        e.preventDefault();
        e.stopPropagation();
        const form = $(this).parents('form:first');
        form.attr('action', '/action/cancel/scheduling');
        form[0].requestSubmit(e.target);
    });

    let maxLengthSMS = $('textarea#communication-content-sms').attr('maxlength');
    $(document).ready(function () {
        $('div.sms span.length').html(maxLengthSMS - $('textarea#communication-content-sms').val().length);
    });

    $('textarea#communication-content-sms').keyup(function () {
        let length = $(this).val().length;
        // Refactor !!!
        length = maxLengthSMS - length;
        if (length > 1) {
            $('#characters .length').text(length);
            $('#characters .text').text('s');
        } else {
            $('#characters .length').text(length);
            $('#characters .text').text('');
        }
        var url = document.querySelector('#sms-preview a');
        $('#sms-preview span').html($(this).val()).append('<br />').append(url);
    });

    let maxLengthTwitter = $('textarea#communication-object-twitter').attr('maxlength');
    $(document).ready(function () {
        $('div.twitter span.length').html(maxLengthTwitter -  $('textarea#communication-object-twitter').val().length);
    });

    $('textarea#communication-object-twitter').keyup(function () {
        let length = $(this).val().length;
        length = maxLengthTwitter - length;
        if (length > 1) {
            $('#characters .length').text(length);
            $('#characters .text').text('s');
        } else {
            $('#characters .length').text(length);
            $('#characters .text').text('');
        }
        let url = document.querySelector('#tweet_message a');
        $('#tweet_message span').html($(this).val()).append('<br />').append(url);
    });

    $('textarea#communication-content-facebook').keyup(function () {
        $('#facebook_message span').html($(this).val());
    });

    document.getElementById('toggle-edit-preview').addEventListener('change', function(){
        const label = document.querySelector('label[for="'+this.id+'"]');
        if(this.checked) {
            label.classList.remove(label.getAttribute('data-gn-unchecked-class'));
            label.classList.add(label.getAttribute('data-gn-checked-class'));
            label.textContent = label.getAttribute('data-gn-checked-label');

            $('div#email-preview').hide();
            $('div#edit-email-textarea').show();
        } else {
            tinymce.triggerSave();
            const form = this.closest('form');
            $.ajax({
                url: '/action/communication/preview/EMAIL',
                method: 'POST',
                data: $(form).serialize(),
                success: function (data) {
                    $('#email-preview').html(data);
                },
                error: function (er) {
                    GN.displayMessage('error', 'Une erreur est survenue lors de la génération de la prévisualisation de l\'email');
                    document.querySelector('#message-area').scrollIntoView({ behavior: "smooth" });
                }
            });

            label.classList.remove(label.getAttribute('data-gn-checked-class'));
            label.classList.add(label.getAttribute('data-gn-unchecked-class'));
            label.textContent = label.getAttribute('data-gn-unchecked-label');

            $('div#email-preview').show();
            $('div#edit-email-textarea').hide();
        }
    })

    tinymce.init({
        selector: 'textarea#communication-content-email',
        height: 400,
        menubar: false,
        branding: false,
        readonly: $('fieldset#publicationEmailForm').attr('disabled') === 'disabled' ? 1 : 0,
        language: 'fr_FR',
        plugins: 'preview searchreplace autolink directionality code visualblocks visualchars fullscreen table nonbreaking insertdatetime advlist lists wordcount charmap link',
        toolbar: 'undo redo | bold italic underline strikethrough formatselect removeformat| alignleft aligncenter alignright alignjustify | numlist bullist | link',
        importcss_append: true,
        quickbars_selection_toolbar: 'bold italic | h2 h3 blockquote quicktable'
    });
</script>

{% endautoescape %}
{% endblock %}
